NDB_TOP(1)

NAME
ndb_top - View CPU usage information for NDB threads

SYNOPSIS

ndb_top options

DESCRIPTION

ndb_top displays running information in the terminal about CPU usage by NDB threads on an NDB Cluster data node. Each thread is represented by two rows in the output, the first showing system statistics, the second showing the measured statistics for the thread.

ndb_top is available in MySQL NDB Cluster 7.6 (and later). Usage

    ndb_top [-h hostname] [-t port] [-u user] [-p pass] [-n node_id]

ndb_top connects to a MySQL Server running as an SQL node of the cluster. By default, it attempts to connect to a mysqld running on localhost and port 3306, as the MySQL root user with no password specified. You can override the default host and port using, respectively, --host (-h) and --port (-t). To specify a MySQL user and password, use the --user (-u) and --passwd (-p) options. This user must be able to read tables in the ndbinfo database (ndb_top uses information from ndbinfo.cpustat and related tables).

For more information about MySQL user accounts and passwords, see Section 6.2, “Access Control and Account Management”.

Output is available as plain text or an ASCII graph; you can specify this using the --text (-x) and --graph (-g) options, respectively. These two display modes provide the same information; they can be used concurrently. At least one display mode must be in use.

Color display of the graph is supported and enabled by default (--color or -c option). With color support enabled, the graph display shows OS user time in blue, OS system time in green, and idle time as blank. For measured load, blue is used for execution time, yellow for send time, red for time spent in send buffer full waits, and blank spaces for idle time. The percentage shown in the graph display is the sum of percentages for all threads which are not idle. Colors are not currently configurable; you can use grayscale instead by using --skip-color.

The sorted view (--sort, -r) is based on the maximum of the measured load and the load reported by the OS. Display of these can be enabled and disabled using the --measured-load (-m) and --os-load (-o) options. Display of at least one of these loads must be enabled.

The program tries to obtain statistics from a data node having the node ID given by the --node-id (-n) option; if unspecified, this is 1. ndb_top cannot provide information about other types of nodes.

The view adjusts itself to the height and width of the terminal window; the minimum supported width is 76 characters.

Once started, ndb_top runs continuously until forced to exit; you can quit the program using Ctrl-C. The display updates once per second; to set a different delay interval, use --sleep-time (-s).

    Note

    ndb_top is available on macOS, Linux, and Solaris. It is not currently supported on Windows platforms.

The following table includes all options that are specific to the NDB Cluster program ndb_top. Additional descriptions follow the table.

Table 21.46. Command-line options used with the program ndb_top
Format | Description | Added, Deprecated, or Removed
--color, -c | Show ASCII graphs in color; use --skip-colors to disable | ADDED: NDB 7.6.3
--defaults-extra-file=path | Read given file after global files are read | (Supported in all NDB releases based on MySQL 5.7)
--defaults-file=path | Read default options from given file only | (Supported in all NDB releases based on MySQL 5.7)
--defaults-group-suffix=string | Also read groups with concat(group, suffix) | (Supported in all NDB releases based on MySQL 5.7)
--graph, -g | Display data using graphs; use --skip-graphs to disable | ADDED: NDB 7.6.3
--help | Show program usage information | ADDED: NDB 7.6.3
--host=string, -h string | Host name or IP address of MySQL Server to connect to | ADDED: NDB 7.6.3
--login-path=path | Read given path from login file | (Supported in all NDB releases based on MySQL 5.7)
--measured-load, -m | Show measured load by thread | ADDED: NDB 7.6.3
--no-defaults | Do not read default options from any option file other than login file | (Supported in all NDB releases based on MySQL 5.7)
--node-id=#, -n # | Watch node having this node ID | ADDED: NDB 7.6.3
--os-load, -o | Show load measured by operating system | ADDED: NDB 7.6.3
--passwd=password, -p password | Connect using this password (same as --password option) | ADDED: NDB 7.6.3 REMOVED: NDB 7.6.4
--password=password, -p password | Connect using this password | ADDED: NDB 7.6.6
--port=#, -t # (<=7.6.5), -P # (>=7.6.6) | Port number to use when connecting to MySQL Server | ADDED: NDB 7.6.3
--print-defaults | Print program argument list and exit | (Supported in all NDB releases based on MySQL 5.7)
--sleep-time=#, -s # | Time to wait between display refreshes, in seconds | ADDED: NDB 7.6.3
--socket=path, -S path | Socket file to use for connection | ADDED: NDB 7.6.6
--sort, -r | Sort threads by usage; use --skip-sort to disable | ADDED: NDB 7.6.3
--text, -x (<=7.6.5), -t (>=7.6.6) | Display data using text | ADDED: NDB 7.6.3
--usage | Show program usage information; same as --help | ADDED: NDB 7.6.3
--user=name, -u name | Connect as this MySQL user | ADDED: NDB 7.6.3

Additional Options

    • --color, -c
    Command-Line Format | --color
    Introduced | 5.7.19-ndb-7.6.3

    Show ASCII graphs in color; use --skip-colors to disable.

    • --defaults-extra-file
    Command-Line Format | --defaults-extra-file=path
    Type | String
    Default Value | [none]

    Read given file after global files are read.

    • --defaults-file
    Command-Line Format | --defaults-file=path
    Type | String
    Default Value | [none]

    Read default options from given file only.

    • --defaults-group-suffix
    Command-Line Format | --defaults-group-suffix=string
    Type | String
    Default Value | [none]

    Also read groups with concat(group, suffix).

    • --graph, -g
    Command-Line Format | --graph
    Introduced | 5.7.19-ndb-7.6.3

    Display data using graphs; use --skip-graphs to disable. This option or --text must be true; both options may be true.

    • --help, -?
    Command-Line Format | --help
    Introduced | 5.7.19-ndb-7.6.3

    Show program usage information.

    • --host[=name], -h
    Command-Line Format | --host=string
    Introduced | 5.7.19-ndb-7.6.3
    Type | String
    Default Value | localhost

    Host name or IP address of MySQL Server to connect to.

    • --login-path
    Command-Line Format | --login-path=path
    Type | String
    Default Value | [none]

    Read given path from login file.

    • --measured-load, -m
    Command-Line Format | --measured-load
    Introduced | 5.7.19-ndb-7.6.3

    Show measured load by thread. This option or --os-load must be true; both options may be true.

    • --no-defaults
    Command-Line Format | --no-defaults

    Do not read default options from any option file other than login file.

    • --node-id[=#], -n
    Command-Line Format | --node-id=#
    Introduced | 5.7.19-ndb-7.6.3
    Type | Integer
    Default Value | 1

    Watch the data node having this node ID.

    • --os-load, -o
    Command-Line Format | --os-load
    Introduced | 5.7.19-ndb-7.6.3

    Show load measured by operating system. This option or --measured-load must be true; both options may be true.

    • --passwd[=password], -p
    Command-Line Format | --passwd=password
    Introduced | 5.7.19-ndb-7.6.3
    Removed | 5.7.20-ndb-7.6.4
    Type | String
    Default Value | NULL

    Connect to a MySQL Server using this password and the MySQL user specified by --user. Synonym for --password.

    This password is associated with a MySQL user account only, and is not related in any way to the password used with encrypted NDB backups.

    • --password[=password], -p
    Command-Line Format | --password=password
    Introduced | 5.7.22-ndb-7.6.6
    Type | String
    Default Value | NULL

    Connect to a MySQL Server using this password and the MySQL user specified by --user.

    This password is associated with a MySQL user account only, and is not related in any way to the password used with encrypted NDB backups.

    • --port[=#], -P
    Command-Line Format | --port=#
    Introduced | 5.7.19-ndb-7.6.3
    Type | Integer
    Default Value | 3306

    Port number to use when connecting to MySQL Server.

    (Formerly, the short form for this option was -t, which was repurposed as the short form of --text.)

    • --print-defaults
    Command-Line Format | --print-defaults

    Print program argument list and exit.

    • --sleep-time[=seconds], -s
    Command-Line Format | --sleep-time=#
    Introduced | 5.7.19-ndb-7.6.3
    Type | Integer
    Default Value | 1

    Time to wait between display refreshes, in seconds.

    • --socket=path/to/file, -S
    Command-Line Format | --socket=path
    Introduced | 5.7.22-ndb-7.6.6
    Type | Path name
    Default Value | [none]

    Use the specified socket file for the connection.

    • --sort, -r
    Command-Line Format | --sort
    Introduced | 5.7.19-ndb-7.6.3

    Sort threads by usage; use --skip-sort to disable.

    • --text, -t
    Command-Line Format | --text
    Introduced | 5.7.19-ndb-7.6.3

    Display data using text. This option or --graph must be true; both options may be true.

    (The short form for this option was -x in previous versions of NDB Cluster, but this is no longer supported.)

    • --usage
    Command-Line Format | --usage
    Introduced | 5.7.19-ndb-7.6.3

    Display help text and exit; same as --help.

    • --user[=name], -u
    Command-Line Format | --user=name
    Introduced | 5.7.19-ndb-7.6.3
    Type | String
    Default Value | root

    Connect as this MySQL user. Normally requires a password supplied by the --password option.

Sample Output. The next figure shows ndb_top running in a terminal window on a Linux system with an ndbmtd data node under a moderate load. Here, the program has been invoked using ndb_top -n8 -x to provide both text and graph output:

Figure 21.38. ndb_top Running in Terminal

    [IMAGE][1] [IMAGE][1] Display from ndb_top, running in a
                terminal window. Shows information for each node, including
                the utilized resources.

COPYRIGHT

Copyright © 1997, 2022, Oracle and/or its affiliates.

This documentation is free software; you can redistribute it and/or modify it only under the terms of the GNU General Public License as published by the Free Software Foundation; version 2 of the License.

This documentation is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA or see http://www.gnu.org/licenses/.

NOTES

1.  [set $man.base.url.for.relative.links]/../refman-common/images/published/ndb-top-1.png

SEE ALSO
For more information, please refer to the MySQL Reference Manual, which may already be installed locally and which is also available online at http://dev.mysql.com/doc/.

AUTHOR
Oracle Corporation (http://dev.mysql.com/).